searchData={"items":[{"type":"task","title":"mix wayfinder.generate","doc":"Generates TypeScript routes based on your Phoenix router routes.","ref":"Mix.Tasks.Wayfinder.Generate.html"},{"type":"function","title":"Mix.Tasks.Wayfinder.Generate.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Wayfinder.Generate.html#run/1"},{"type":"module","title":"Wayfinder.FileWriter","doc":"This module is responsible for writing generated Typescript code to\nthe destination folder","ref":"Wayfinder.FileWriter.html"},{"type":"function","title":"Wayfinder.FileWriter.build_paths/2","doc":"","ref":"Wayfinder.FileWriter.html#build_paths/2"},{"type":"type","title":"Wayfinder.FileWriter.paths/0","doc":"","ref":"Wayfinder.FileWriter.html#t:paths/0"},{"type":"function","title":"Wayfinder.FileWriter.prepare/1","doc":"","ref":"Wayfinder.FileWriter.html#prepare/1"},{"type":"function","title":"Wayfinder.FileWriter.write/2","doc":"","ref":"Wayfinder.FileWriter.html#write/2"},{"type":"module","title":"Wayfinder.Options","doc":"Options for Wayfinder route generation.","ref":"Wayfinder.Options.html"},{"type":"function","title":"Wayfinder.Options.build_opts/2","doc":"","ref":"Wayfinder.Options.html#build_opts/2"},{"type":"type","title":"Wayfinder.Options.t/0","doc":"","ref":"Wayfinder.Options.html#t:t/0"},{"type":"module","title":"Wayfinder.PhoenixRouter","doc":"After your Phoenix application is compiled the Typescript routes will be generated","ref":"Wayfinder.PhoenixRouter.html"},{"type":"function","title":"Wayfinder.PhoenixRouter.after_compile/2","doc":"","ref":"Wayfinder.PhoenixRouter.html#after_compile/2"},{"type":"module","title":"Wayfinder.Processor.BuildParams","doc":"We get for each route a map of all their arguments and if they are optional or not.\n\nExample:\nget \"/users/:id\", UserController, :show\nget \"/users/:id/:name\", UserController, :show\n\nIn this case `:id` is required and `:name` is optional.","ref":"Wayfinder.Processor.BuildParams.html"},{"type":"function","title":"Wayfinder.Processor.BuildParams.build/2","doc":"","ref":"Wayfinder.Processor.BuildParams.html#build/2"},{"type":"function","title":"Wayfinder.Processor.BuildParams.build_param_spec/3","doc":"","ref":"Wayfinder.Processor.BuildParams.html#build_param_spec/3"},{"type":"type","title":"Wayfinder.Processor.BuildParams.counts_acc/0","doc":"","ref":"Wayfinder.Processor.BuildParams.html#t:counts_acc/0"},{"type":"type","title":"Wayfinder.Processor.BuildParams.http_method/0","doc":"","ref":"Wayfinder.Processor.BuildParams.html#t:http_method/0"},{"type":"type","title":"Wayfinder.Processor.BuildParams.method_acc/0","doc":"","ref":"Wayfinder.Processor.BuildParams.html#t:method_acc/0"},{"type":"type","title":"Wayfinder.Processor.BuildParams.param_count/0","doc":"","ref":"Wayfinder.Processor.BuildParams.html#t:param_count/0"},{"type":"type","title":"Wayfinder.Processor.BuildParams.param_name/0","doc":"","ref":"Wayfinder.Processor.BuildParams.html#t:param_name/0"},{"type":"function","title":"Wayfinder.Processor.BuildParams.params_count/1","doc":"","ref":"Wayfinder.Processor.BuildParams.html#params_count/1"},{"type":"type","title":"Wayfinder.Processor.BuildParams.totals_acc/0","doc":"","ref":"Wayfinder.Processor.BuildParams.html#t:totals_acc/0"},{"type":"module","title":"Wayfinder.Processor.GroupRoutes","doc":"Handle `%Phoenix.Router.Route{}` entries —\nThese are the steps in this module.\n\n1. Group routes by their controller and action.\n2. Routes are grouped by shared static path prefix. Ex.: `/users/:id` and `users/:id/:name`\n3. Within each group, the path with the most parameters becomes canonical. Ex.: `/users/:id/:name`\n4. Routes are sorted with the shortest path first.\n5. All methods across the group are merged.\n6. Argument handling is inferred based on the variation in path parameters arity.\n7. We get for each route a map of all their arguments and if they are optional or not.\n\nAlso this is my best shot to simulating Phoenix has built-in support for optional parameters\nin the router. This is not a feature of Phoenix but if 2 routes are declared with 2 paths like this\n\n```elixir\nget \"/users/:id\", UserController, :show\nget \"/users/:id/:name\", UserController, :show\n```\n\nThis is the logic here:\nWe assume `:name` is optional and `:id` is required.\n\nWe do all of this to generate a compresive TypeScript route definition\n\nThe final out is a list of `%Wayfinder.Processor.Route{}` structs","ref":"Wayfinder.Processor.GroupRoutes.html"},{"type":"function","title":"Wayfinder.Processor.GroupRoutes.call/2","doc":"","ref":"Wayfinder.Processor.GroupRoutes.html#call/2"},{"type":"type","title":"Wayfinder.Processor.GroupRoutes.indexed_variant/0","doc":"","ref":"Wayfinder.Processor.GroupRoutes.html#t:indexed_variant/0"},{"type":"type","title":"Wayfinder.Processor.GroupRoutes.variant/0","doc":"","ref":"Wayfinder.Processor.GroupRoutes.html#t:variant/0"},{"type":"module","title":"Wayfinder.Processor.IgnoreFilter","doc":"Handles filtering of Phoenix routes based on ignore patterns configured in the application.\n\nSupports regex patterns to ignore routes that match specific path patterns.\nPatterns are compiled once and cached for performance.","ref":"Wayfinder.Processor.IgnoreFilter.html"},{"type":"function","title":"Wayfinder.Processor.IgnoreFilter.call/0","doc":"Gets compiled ignore patterns from persistent term cache.\nInitializes patterns if not already cached.","ref":"Wayfinder.Processor.IgnoreFilter.html#call/0"},{"type":"type","title":"Wayfinder.Processor.IgnoreFilter.compiled_patterns/0","doc":"","ref":"Wayfinder.Processor.IgnoreFilter.html#t:compiled_patterns/0"},{"type":"function","title":"Wayfinder.Processor.IgnoreFilter.ignore?/2","doc":"","ref":"Wayfinder.Processor.IgnoreFilter.html#ignore?/2"},{"type":"module","title":"Wayfinder.Processor.Introspect","doc":"Extracts `{line, file}` metadata for a given controller and action.\n\nUsed to emit `@see` references for frontend route/action generators.","ref":"Wayfinder.Processor.Introspect.html"},{"type":"type","title":"Wayfinder.Processor.Introspect.location/0","doc":"","ref":"Wayfinder.Processor.Introspect.html#t:location/0"},{"type":"function","title":"Wayfinder.Processor.Introspect.source_location/2","doc":"Returns the `{line, file}` where the given controller `module` and `action` are defined.\n\nReturns `nil` if not available.","ref":"Wayfinder.Processor.Introspect.html#source_location/2"},{"type":"function","title":"Example - Wayfinder.Processor.Introspect.source_location/2","doc":"iex> source_location(MyAppWeb.PostController, :index)\n    {15, \"/app/lib/my_app_web/controllers/post_controller.ex\"}","ref":"Wayfinder.Processor.Introspect.html#source_location/2-example"},{"type":"module","title":"Wayfinder.Processor.Route","doc":"Represents a simplified Phoenix route for TypeScript generation.","ref":"Wayfinder.Processor.Route.html"},{"type":"function","title":"Wayfinder.Processor.Route.from_phoenix_route/2","doc":"Converts a raw %Phoenix.Router.Route{} into a %Wayfinder.Route{}.","ref":"Wayfinder.Processor.Route.html#from_phoenix_route/2"},{"type":"function","title":"Wayfinder.Processor.Route.js_method/1","doc":"Generate a JS-safe method name for controller actions","ref":"Wayfinder.Processor.Route.html#js_method/1"},{"type":"function","title":"Wayfinder.Processor.Route.normalize_verbs/1","doc":"","ref":"Wayfinder.Processor.Route.html#normalize_verbs/1"},{"type":"type","title":"Wayfinder.Processor.Route.param_spec/0","doc":"","ref":"Wayfinder.Processor.Route.html#t:param_spec/0"},{"type":"type","title":"Wayfinder.Processor.Route.params_by_method/0","doc":"","ref":"Wayfinder.Processor.Route.html#t:params_by_method/0"},{"type":"type","title":"Wayfinder.Processor.Route.phoenix_route_opts/0","doc":"","ref":"Wayfinder.Processor.Route.html#t:phoenix_route_opts/0"},{"type":"type","title":"Wayfinder.Processor.Route.t/0","doc":"","ref":"Wayfinder.Processor.Route.html#t:t/0"},{"type":"module","title":"Wayfinder.RoutesWatcher","doc":"A GenServer that watches for changes to router files and regenerates routes.\n\nCredit to:\nhttps://github.com/assimelha/routes/blob/master/lib/routes/watcher.ex\n\nThis module provides functionality to:\n- Watch for file system changes in the current working directory\n- Detect modifications to router.ex files\n- Automatically regenerate routes when router files change","ref":"Wayfinder.RoutesWatcher.html"},{"type":"function","title":"Wayfinder.RoutesWatcher.child_spec/1","doc":"Child spec for supervision tree.","ref":"Wayfinder.RoutesWatcher.html#child_spec/1"},{"type":"function","title":"Wayfinder.RoutesWatcher.compile_router/2","doc":"","ref":"Wayfinder.RoutesWatcher.html#compile_router/2"},{"type":"function","title":"Wayfinder.RoutesWatcher.handle_call/3","doc":"Handles synchronous calls. Used for testing to ensure message processing is complete.","ref":"Wayfinder.RoutesWatcher.html#handle_call/3"},{"type":"function","title":"Wayfinder.RoutesWatcher.handle_info/2","doc":"Handles file system events, specifically looking for router.ex file modifications.","ref":"Wayfinder.RoutesWatcher.html#handle_info/2"},{"type":"function","title":"Wayfinder.RoutesWatcher.init/1","doc":"Initializes the watcher by starting a FileSystem process and subscribing to events.","ref":"Wayfinder.RoutesWatcher.html#init/1"},{"type":"function","title":"Wayfinder.RoutesWatcher.start_link/1","doc":"Starts the watcher process.","ref":"Wayfinder.RoutesWatcher.html#start_link/1"},{"type":"function","title":"Options - Wayfinder.RoutesWatcher.start_link/1","doc":"* `:generator_module` - Module to use for route generation (defaults to Wayfinder)\n* `:compiler_fun` - Function to call when compiling router files (optional)\n\nAccepts GenServer options. The process will be registered under the module name.","ref":"Wayfinder.RoutesWatcher.html#start_link/1-options"},{"type":"module","title":"Wayfinder.Typescript.BuildActions","doc":"Generates a Typescript code for a controller / action\nEach action can have one or more routes, and each route can have one or more HTTP methods.\nWhen user define this kind of routes\n\n```elixir\nget \"/users\", UserController, :my_action\npost \"/users\", UserController, :my_action\n```\nIt should generate only one myAction.url specification with\nall the methods that this action can handle according to the router.","ref":"Wayfinder.Typescript.BuildActions.html"},{"type":"function","title":"Wayfinder.Typescript.BuildActions.call/1","doc":"","ref":"Wayfinder.Typescript.BuildActions.html#call/1"},{"type":"function","title":"Wayfinder.Typescript.BuildActions.main_method/1","doc":"","ref":"Wayfinder.Typescript.BuildActions.html#main_method/1"},{"type":"type","title":"Wayfinder.Typescript.BuildActions.opts/0","doc":"","ref":"Wayfinder.Typescript.BuildActions.html#t:opts/0"},{"type":"module","title":"Wayfinder.Typescript.BuildController","doc":"Generates a Typescript controller for a given route.\nThe controller includes all actions found in the Phoenix router.","ref":"Wayfinder.Typescript.BuildController.html"},{"type":"function","title":"Wayfinder.Typescript.BuildController.call/2","doc":"","ref":"Wayfinder.Typescript.BuildController.html#call/2"},{"type":"exception","title":"Wayfinder.Error","doc":"Custom Wayfinder-specific error struct and reason definitions.","ref":"Wayfinder.Error.html"},{"type":"function","title":"Wayfinder.Error.new/2","doc":"Creates a new Wayfinder.Error.","ref":"Wayfinder.Error.html#new/2"},{"type":"function","title":"Examples - Wayfinder.Error.new/2","doc":"iex> Wayfinder.Error.new(\"Failed to build tree\", :tree_build_error)\n    %Wayfinder.Error{message: \"Failed to build tree\", reason: :tree_build_error}","ref":"Wayfinder.Error.html#new/2-examples"},{"type":"type","title":"Wayfinder.Error.reason/0","doc":"","ref":"Wayfinder.Error.html#t:reason/0"},{"type":"type","title":"Wayfinder.Error.t/0","doc":"","ref":"Wayfinder.Error.html#t:t/0"},{"type":"extras","title":"README","doc":"[![CI](https://github.com/andresgutgon/phoenix-wayfinder/actions/workflows/ci.yml/badge.svg?branch=main)](https://github.com/andresgutgon/phoenix-wayfinder/actions/workflows/ci.yml)\n\n# Wayfinder\nMake the readme","ref":"readme.html"},{"type":"extras","title":"License","doc":"# License\n\nMIT License\n\nCopyright (c) 2025 Andrés Gutiérrez\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}